#ifndef _SN_STRUCT_
#define _SN_STRUCT_

//*****************************************************
// Class to store the geometric data for internal use.
// Authors: Sergi Funtan & Nicolau Sunyer
// 2005 University of Girona.
//*****************************************************

typedef struct
{
public:
	float _reflect[3];
}snMaterial;


typedef struct{
	int _numTris;
	snMaterial _mat;

	int _numVer;
	float *_ver;
	float *_nor;
	float *_tex;	
	float *_refl;
	int *_index;

	unsigned int	m_nVBOVertices;				// Name of the VBO of Vertex positions.
	unsigned int	m_nVBONormals;				// Name of the VBO of Vertex Normals.
	unsigned int	m_nVBOTexCoords;			// Name of the VBO of Texture Coordinates.
	unsigned int	m_nVBOColors;
	unsigned int	m_nVBOIndexs;				// Name of the VBO of Vertex Indexs.
}snTriSet;

typedef struct{
	int _numTriSets;
	snTriSet *_triSet;
}snGeo;

typedef struct{
	int _numGeos;
	snGeo *_geo;
}snObject;


#endif